;; Copyright (c) Iwata <iwata@quasiquote.org>
;;
;; Permission is hereby granted, free of charge, to any person obtaining
;; a copy of this software and associated documentation files (the
;; "Software"), to deal in the Software without restriction, including
;; without limitation the rights to use, copy, modify, merge, publish,
;; distribute, sublicense, and/or sell copies of the Software, and to
;; permit persons to whom the Software is furnished to do so, subject to
;; the following conditions:
;;
;; The above copyright notice and this permission notice shall be included
;; in all copies or substantial portions of the Software.
;;
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
;; IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
;; CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
;; TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
;; SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

(declare
 (unit twitter-libnotify)
 (export
  notify-init
  notify-uninit
  notify-init?
  notify-notification-new
  notify-notification-delete!
  notify-notification-timeout!
  notify-notification-urgency!
  notify-notification-show
  ))

(define-constant *NOTIFY_URGENCY_LOW* 0)
(define-constant *NOTIFY_URGENCY_NORMAL* 1)
(define-constant *NOTIFY_URGENCY_CRITICAL* 2)

(define notify-init     (foreign-safe-lambda bool "notify_init" c-string))
(define notify-uninit   (foreign-safe-lambda void "notify_uninit"))
(define notify-init?    (foreign-safe-lambda bool "notify_is_initted"))
(define notify-notification-new (foreign-safe-lambda c-pointer "notify_notification_new"
                                                     c-string c-string c-string c-pointer))
(define notify-notification-delete! (foreign-safe-lambda void "g_object_unref" c-pointer))
(define notify-notification-timeout! (foreign-safe-lambda void "notify_notification_set_timeout"
                                                          c-pointer integer))
(define notify-notification-urgency! (foreign-safe-lambda void "notify_notification_set_urgency"
                                                          c-pointer integer))
(define notify-notification-show (foreign-safe-lambda bool "notify_notification_show"
                                                      c-pointer c-pointer))





